diff --git a/compiler/typecheck/TcClassDcl.lhs b/compiler/typecheck/TcClassDcl.lhs
index 835043a..7dd051b 100644
--- a/compiler/typecheck/TcClassDcl.lhs
+++ b/compiler/typecheck/TcClassDcl.lhs
@@ -6,19 +6,13 @@
 Typechecking class declarations
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcClassDcl ( tcClassSigs, tcClassDecl2, 
-		    findMethodBind, instantiateMethod, tcInstanceMethodBody,
-		    tcClassMinimalDef,
+                    findMethodBind, instantiateMethod, tcInstanceMethodBody,
+                    tcClassMinimalDef,
                     HsSigFun, mkHsSigFun, lookupHsSig, emptyHsSigs,
-		    tcMkDeclCtxt, tcAddDeclCtxt, badMethodErr
-		  ) where
+                    tcMkDeclCtxt, tcAddDeclCtxt, badMethodErr
+                  ) where
 
 #include "HsVersions.h"
 
@@ -58,45 +52,45 @@ Dictionary handling
 Every class implicitly declares a new data type, corresponding to dictionaries
 of that class. So, for example:
 
-	class (D a) => C a where
-	  op1 :: a -> a
-	  op2 :: forall b. Ord b => a -> b -> b
+        class (D a) => C a where
+          op1 :: a -> a
+          op2 :: forall b. Ord b => a -> b -> b
 
 would implicitly declare
 
-	data CDict a = CDict (D a)	
-			     (a -> a)
-			     (forall b. Ord b => a -> b -> b)
+        data CDict a = CDict (D a)      
+                             (a -> a)
+                             (forall b. Ord b => a -> b -> b)
 
 (We could use a record decl, but that means changing more of the existing apparatus.
 One step at at time!)
 
 For classes with just one superclass+method, we use a newtype decl instead:
 
-	class C a where
-	  op :: forallb. a -> b -> b
+        class C a where
+          op :: forallb. a -> b -> b
 
 generates
 
-	newtype CDict a = CDict (forall b. a -> b -> b)
+        newtype CDict a = CDict (forall b. a -> b -> b)
 
 Now DictTy in Type is just a form of type synomym: 
-	DictTy c t = TyConTy CDict `AppTy` t
+        DictTy c t = TyConTy CDict `AppTy` t
 
 Death to "ExpandingDicts".
 
 
 %************************************************************************
-%*									*
-		Type-checking the class op signatures
-%*									*
+%*                                                                      *
+                Type-checking the class op signatures
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-tcClassSigs :: Name	             -- Name of the class
-	    -> [LSig Name]
-	    -> LHsBinds Name
-	    -> TcM ([TcMethInfo],    -- Exactly one for each method
+tcClassSigs :: Name                  -- Name of the class
+            -> [LSig Name]
+            -> LHsBinds Name
+            -> TcM ([TcMethInfo],    -- Exactly one for each method
                     NameEnv Type)    -- Types of the generic-default methods
 tcClassSigs clas sigs def_methods
   = do { traceTc "tcClassSigs 1" (ppr clas)
@@ -109,23 +103,23 @@ tcClassSigs clas sigs def_methods
        ; let op_names = mkNameSet [ n | (n,_,_) <- op_info ]
        ; sequence_ [ failWithTc (badMethodErr clas n)
                    | n <- dm_bind_names, not (n `elemNameSet` op_names) ]
-		   -- Value binding for non class-method (ie no TypeSig)
+                   -- Value binding for non class-method (ie no TypeSig)
 
        ; sequence_ [ failWithTc (badGenericMethod clas n)
                    | (n,_) <- gen_dm_prs, not (n `elem` dm_bind_names) ]
-		   -- Generic signature without value binding
+                   -- Generic signature without value binding
 
        ; traceTc "tcClassSigs 2" (ppr clas)
        ; return (op_info, gen_dm_env) }
   where
     vanilla_sigs = [L loc (nm,ty) | L loc (TypeSig    nm ty) <- sigs]
     gen_sigs     = [L loc (nm,ty) | L loc (GenericSig nm ty) <- sigs]
-    dm_bind_names :: [Name]	-- These ones have a value binding in the class decl
+    dm_bind_names :: [Name]     -- These ones have a value binding in the class decl
     dm_bind_names = [op | L _ (FunBind {fun_id = L _ op}) <- bagToList def_methods]
 
     tc_sig genop_env (op_names, op_hs_ty)
       = do { traceTc "ClsSig 1" (ppr op_names)
-           ; op_ty <- tcClassSigType op_hs_ty	-- Class tyvars already in scope
+           ; op_ty <- tcClassSigType op_hs_ty   -- Class tyvars already in scope
            ; traceTc "ClsSig 2" (ppr op_names)
            ; return [ (op_name, f op_name, op_ty) | L _ op_name <- op_names ] }
            where
@@ -140,46 +134,46 @@ tcClassSigs clas sigs def_methods
 
 
 %************************************************************************
-%*									*
-		Class Declarations
-%*									*
+%*                                                                      *
+                Class Declarations
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-tcClassDecl2 :: LTyClDecl Name		-- The class declaration
-	     -> TcM (LHsBinds Id)
+tcClassDecl2 :: LTyClDecl Name          -- The class declaration
+             -> TcM (LHsBinds Id)
 
 tcClassDecl2 (L loc (ClassDecl {tcdLName = class_name, tcdSigs = sigs, 
-				tcdMeths = default_binds}))
-  = recoverM (return emptyLHsBinds)	$
-    setSrcSpan loc		   	$
+                                tcdMeths = default_binds}))
+  = recoverM (return emptyLHsBinds)     $
+    setSrcSpan loc                      $
     do  { clas <- tcLookupLocatedClass class_name
 
-	-- We make a separate binding for each default method.
-	-- At one time I used a single AbsBinds for all of them, thus
-	-- AbsBind [d] [dm1, dm2, dm3] { dm1 = ...; dm2 = ...; dm3 = ... }
-	-- But that desugars into
-	--	ds = \d -> (..., ..., ...)
-	--	dm1 = \d -> case ds d of (a,b,c) -> a
-	-- And since ds is big, it doesn't get inlined, so we don't get good
-	-- default methods.  Better to make separate AbsBinds for each
-	; let
-	      (tyvars, _, _, op_items) = classBigSig clas
+        -- We make a separate binding for each default method.
+        -- At one time I used a single AbsBinds for all of them, thus
+        -- AbsBind [d] [dm1, dm2, dm3] { dm1 = ...; dm2 = ...; dm3 = ... }
+        -- But that desugars into
+        --      ds = \d -> (..., ..., ...)
+        --      dm1 = \d -> case ds d of (a,b,c) -> a
+        -- And since ds is big, it doesn't get inlined, so we don't get good
+        -- default methods.  Better to make separate AbsBinds for each
+        ; let
+              (tyvars, _, _, op_items) = classBigSig clas
               prag_fn     = mkPragFun sigs default_binds
-	      sig_fn	  = mkHsSigFun sigs
+              sig_fn      = mkHsSigFun sigs
               clas_tyvars = snd (tcSuperSkolTyVars tyvars)
-	      pred  	  = mkClassPred clas (mkTyVarTys clas_tyvars)
-	; this_dict <- newEvVar pred
+              pred        = mkClassPred clas (mkTyVarTys clas_tyvars)
+        ; this_dict <- newEvVar pred
 
-	; traceTc "TIM2" (ppr sigs)
-	; let tc_dm = tcDefMeth clas clas_tyvars
-				this_dict default_binds 
-	      			sig_fn prag_fn
+        ; traceTc "TIM2" (ppr sigs)
+        ; let tc_dm = tcDefMeth clas clas_tyvars
+                                this_dict default_binds 
+                                sig_fn prag_fn
 
-	; dm_binds <- tcExtendTyVarEnv clas_tyvars $
+        ; dm_binds <- tcExtendTyVarEnv clas_tyvars $
                       mapM tc_dm op_items
 
-	; return (unionManyBags dm_binds) }
+        ; return (unionManyBags dm_binds) }
 
 tcClassDecl2 d = pprPanic "tcClassDecl2" (ppr d)
     
@@ -202,20 +196,20 @@ tcDefMeth clas tyvars this_dict binds_in hs_sig_fn prag_fn (sel_id, dm_info)
     sel_name           = idName sel_id
     prags              = prag_fn sel_name
     (dm_bind,bndr_loc) = findMethodBind sel_name binds_in
-	                 `orElse` pprPanic "tcDefMeth" (ppr sel_id)
+                         `orElse` pprPanic "tcDefMeth" (ppr sel_id)
 
     -- Eg.   class C a where
     --          op :: forall b. Eq b => a -> [b] -> a
-    --		gen_op :: a -> a
-    -- 		generic gen_op :: D a => a -> a
+    --          gen_op :: a -> a
+    --          generic gen_op :: D a => a -> a
     -- The "local_dm_ty" is precisely the type in the above
     -- type signatures, ie with no "forall a. C a =>" prefix
 
     tc_dm dm_name 
       = do { dm_id <- tcLookupId dm_name
-	   ; local_dm_name <- setSrcSpan bndr_loc (newLocalName sel_name)
- 	     -- Base the local_dm_name on the selector name, because
- 	     -- type errors from tcInstanceMethodBody come from here
+           ; local_dm_name <- setSrcSpan bndr_loc (newLocalName sel_name)
+             -- Base the local_dm_name on the selector name, because
+             -- type errors from tcInstanceMethodBody come from here
 
            ; dm_id_w_inline <- addInlinePrags dm_id prags
            ; spec_prags     <- tcSpecPrags dm_id prags
@@ -238,18 +232,18 @@ tcDefMeth clas tyvars this_dict binds_in hs_sig_fn prag_fn (sel_id, dm_info)
 ---------------
 tcInstanceMethodBody :: SkolemInfo -> [TcTyVar] -> [EvVar]
                      -> Id -> TcSigInfo
-          	     -> TcSpecPrags -> LHsBind Name 
-          	     -> TcM (LHsBind Id)
+                     -> TcSpecPrags -> LHsBind Name 
+                     -> TcM (LHsBind Id)
 tcInstanceMethodBody skol_info tyvars dfun_ev_vars
                      meth_id local_meth_sig
-		     specs (L loc bind)
-  = do	{ let local_meth_id = sig_id local_meth_sig
+                     specs (L loc bind)
+  = do  { let local_meth_id = sig_id local_meth_sig
               lm_bind = L loc (bind { fun_id = L loc (idName local_meth_id) })
                              -- Substitute the local_meth_name for the binder
-			     -- NB: the binding is always a FunBind
-	; (ev_binds, (tc_bind, _, _)) 
+                             -- NB: the binding is always a FunBind
+        ; (ev_binds, (tc_bind, _, _)) 
                <- checkConstraints skol_info tyvars dfun_ev_vars $
-	          tcPolyCheck NonRecursive no_prag_fn local_meth_sig [lm_bind]
+                  tcPolyCheck NonRecursive no_prag_fn local_meth_sig [lm_bind]
 
         ; let export = ABE { abe_wrap = idHsWrapper, abe_poly = meth_id
                            , abe_mono = local_meth_id, abe_prags = specs }
@@ -260,8 +254,8 @@ tcInstanceMethodBody skol_info tyvars dfun_ev_vars
 
         ; return (L loc full_bind) } 
   where
-    no_prag_fn  _ = []		-- No pragmas for local_meth_id; 
-    		    		-- they are all for meth_id
+    no_prag_fn  _ = []          -- No pragmas for local_meth_id; 
+                                -- they are all for meth_id
 
 ---------------
 tcClassMinimalDef :: Name -> [LSig Name] -> [TcMethInfo] -> TcM ClassMinimalDef
@@ -288,25 +282,25 @@ tcClassMinimalDef _clas sigs op_info
 \begin{code}
 instantiateMethod :: Class -> Id -> [TcType] -> TcType
 -- Take a class operation, say  
---	op :: forall ab. C a => forall c. Ix c => (b,c) -> a
+--      op :: forall ab. C a => forall c. Ix c => (b,c) -> a
 -- Instantiate it at [ty1,ty2]
 -- Return the "local method type": 
---	forall c. Ix x => (ty2,c) -> ty1
+--      forall c. Ix x => (ty2,c) -> ty1
 instantiateMethod clas sel_id inst_tys
   = ASSERT( ok_first_pred ) local_meth_ty
   where
     (sel_tyvars,sel_rho) = tcSplitForAllTys (idType sel_id)
     rho_ty = ASSERT( length sel_tyvars == length inst_tys )
-    	     substTyWith sel_tyvars inst_tys sel_rho
+             substTyWith sel_tyvars inst_tys sel_rho
 
     (first_pred, local_meth_ty) = tcSplitPredFunTy_maybe rho_ty
-    		`orElse` pprPanic "tcInstanceMethod" (ppr sel_id)
+                `orElse` pprPanic "tcInstanceMethod" (ppr sel_id)
 
     ok_first_pred = case getClassPredTys_maybe first_pred of
-		      Just (clas1, _tys) -> clas == clas1
+                      Just (clas1, _tys) -> clas == clas1
                       Nothing -> False
-	      -- The first predicate should be of form (C a b)
-	      -- where C is the class in question
+              -- The first predicate should be of form (C a b)
+              -- where C is the class in question
 
 
 ---------------------------
@@ -324,17 +318,17 @@ lookupHsSig :: HsSigFun -> Name -> Maybe (LHsType Name)
 lookupHsSig = lookupNameEnv
 
 ---------------------------
-findMethodBind	:: Name  	        -- Selector name
-          	-> LHsBinds Name 	-- A group of bindings
-		-> Maybe (LHsBind Name, SrcSpan)
-          	-- Returns the binding, and the binding 
+findMethodBind  :: Name                 -- Selector name
+                -> LHsBinds Name        -- A group of bindings
+                -> Maybe (LHsBind Name, SrcSpan)
+                -- Returns the binding, and the binding 
                 -- site of the method binder
 findMethodBind sel_name binds
   = foldlBag mplus Nothing (mapBag f binds)
   where 
     f bind@(L _ (FunBind { fun_id = L bndr_loc op_name }))
              | op_name == sel_name
-    	     = Just (bind, bndr_loc)
+             = Just (bind, bndr_loc)
     f _other = Nothing
 
 ---------------------------
@@ -349,7 +343,7 @@ Note [Polymorphic methods]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider
     class Foo a where
-	op :: forall b. Ord b => a -> b -> b -> b
+        op :: forall b. Ord b => a -> b -> b -> b
     instance Foo c => Foo [c] where
         op = e
 
@@ -364,18 +358,18 @@ Note [Silly default-method bind]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 When we pass the default method binding to the type checker, it must
 look like    op2 = e
-not  	     $dmop2 = e
+not          $dmop2 = e
 otherwise the "$dm" stuff comes out error messages.  But we want the
 "$dm" to come out in the interface file.  So we typecheck the former,
 and wrap it in a let, thus
-	  $dmop2 = let op2 = e in op2
+          $dmop2 = let op2 = e in op2
 This makes the error messages right.
 
 
 %************************************************************************
-%*									*
-		Error messages
-%*									*
+%*                                                                      *
+                Error messages
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -390,28 +384,28 @@ tcAddDeclCtxt decl thing_inside
 badMethodErr :: Outputable a => a -> Name -> SDoc
 badMethodErr clas op
   = hsep [ptext (sLit "Class"), quotes (ppr clas), 
-	  ptext (sLit "does not have a method"), quotes (ppr op)]
+          ptext (sLit "does not have a method"), quotes (ppr op)]
 
 badGenericMethod :: Outputable a => a -> Name -> SDoc
 badGenericMethod clas op
   = hsep [ptext (sLit "Class"), quotes (ppr clas), 
-	  ptext (sLit "has a generic-default signature without a binding"), quotes (ppr op)]
+          ptext (sLit "has a generic-default signature without a binding"), quotes (ppr op)]
 
 {-
 badGenericInstanceType :: LHsBinds Name -> SDoc
 badGenericInstanceType binds
   = vcat [ptext (sLit "Illegal type pattern in the generic bindings"),
-	  nest 2 (ppr binds)]
+          nest 2 (ppr binds)]
 
 missingGenericInstances :: [Name] -> SDoc
 missingGenericInstances missing
   = ptext (sLit "Missing type patterns for") <+> pprQuotedList missing
-	  
+          
 dupGenericInsts :: [(TyCon, InstInfo a)] -> SDoc
 dupGenericInsts tc_inst_infos
   = vcat [ptext (sLit "More than one type pattern for a single generic type constructor:"),
-	  nest 2 (vcat (map ppr_inst_ty tc_inst_infos)),
-	  ptext (sLit "All the type patterns for a generic type constructor must be identical")
+          nest 2 (vcat (map ppr_inst_ty tc_inst_infos)),
+          ptext (sLit "All the type patterns for a generic type constructor must be identical")
     ]
   where 
     ppr_inst_ty (_,inst) = ppr (simpleInstInfoTy inst)
diff --git a/compiler/typecheck/TcDefaults.lhs b/compiler/typecheck/TcDefaults.lhs
index d05a948..853701c 100644
--- a/compiler/typecheck/TcDefaults.lhs
+++ b/compiler/typecheck/TcDefaults.lhs
@@ -5,12 +5,6 @@
 \section[TcDefaults]{Typechecking \tr{default} declarations}
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcDefaults ( tcDefaults ) where
 
@@ -32,37 +26,37 @@ import FastString
 
 \begin{code}
 tcDefaults :: [LDefaultDecl Name]
-	   -> TcM (Maybe [Type])    -- Defaulting types to heave
-				    -- into Tc monad for later use
-				    -- in Disambig.
+           -> TcM (Maybe [Type])    -- Defaulting types to heave
+                                    -- into Tc monad for later use
+                                    -- in Disambig.
 
 tcDefaults [] 
-  = getDeclaredDefaultTys	-- No default declaration, so get the
-				-- default types from the envt; 
-				-- i.e. use the curent ones
-				-- (the caller will put them back there)
-	-- It's important not to return defaultDefaultTys here (which
-	-- we used to do) because in a TH program, tcDefaults [] is called
-	-- repeatedly, once for each group of declarations between top-level
-	-- splices.  We don't want to carefully set the default types in
-	-- one group, only for the next group to ignore them and install
-	-- defaultDefaultTys
+  = getDeclaredDefaultTys       -- No default declaration, so get the
+                                -- default types from the envt; 
+                                -- i.e. use the curent ones
+                                -- (the caller will put them back there)
+        -- It's important not to return defaultDefaultTys here (which
+        -- we used to do) because in a TH program, tcDefaults [] is called
+        -- repeatedly, once for each group of declarations between top-level
+        -- splices.  We don't want to carefully set the default types in
+        -- one group, only for the next group to ignore them and install
+        -- defaultDefaultTys
 
 tcDefaults [L _ (DefaultDecl [])]
-  = return (Just [])		-- Default declaration specifying no types
+  = return (Just [])            -- Default declaration specifying no types
 
 tcDefaults [L locn (DefaultDecl mono_tys)]
-  = setSrcSpan locn 			$
-    addErrCtxt defaultDeclCtxt		$
-    do	{ ovl_str <- xoptM Opt_OverloadedStrings
-	; num_class    <- tcLookupClass numClassName
-	; is_str_class <- tcLookupClass isStringClassName
-	; let deflt_clss | ovl_str   = [num_class, is_str_class]
-			 | otherwise = [num_class]
-
-	; tau_tys <- mapM (tc_default_ty deflt_clss) mono_tys
+  = setSrcSpan locn                     $
+    addErrCtxt defaultDeclCtxt          $
+    do  { ovl_str <- xoptM Opt_OverloadedStrings
+        ; num_class    <- tcLookupClass numClassName
+        ; is_str_class <- tcLookupClass isStringClassName
+        ; let deflt_clss | ovl_str   = [num_class, is_str_class]
+                         | otherwise = [num_class]
+
+        ; tau_tys <- mapM (tc_default_ty deflt_clss) mono_tys
     
-	; return (Just tau_tys) }
+        ; return (Just tau_tys) }
 
 tcDefaults decls@(L locn (DefaultDecl _) : _)
   = setSrcSpan locn $
@@ -71,20 +65,20 @@ tcDefaults decls@(L locn (DefaultDecl _) : _)
 
 tc_default_ty :: [Class] -> LHsType Name -> TcM Type
 tc_default_ty deflt_clss hs_ty 
- = do	{ ty <- tcHsSigType DefaultDeclCtxt hs_ty
-	; checkTc (isTauTy ty) (polyDefErr hs_ty)
+ = do   { ty <- tcHsSigType DefaultDeclCtxt hs_ty
+        ; checkTc (isTauTy ty) (polyDefErr hs_ty)
 
-	-- Check that the type is an instance of at least one of the deflt_clss
-	; oks <- mapM (check_instance ty) deflt_clss
-	; checkTc (or oks) (badDefaultTy ty deflt_clss)
-	; return ty }
+        -- Check that the type is an instance of at least one of the deflt_clss
+        ; oks <- mapM (check_instance ty) deflt_clss
+        ; checkTc (or oks) (badDefaultTy ty deflt_clss)
+        ; return ty }
 
 check_instance :: Type -> Class -> TcM Bool
   -- Check that ty is an instance of cls
   -- We only care about whether it worked or not; return a boolean
 check_instance ty cls
-  = do	{ (_, mb_res) <- tryTc (simplifyDefault [mkClassPred cls [ty]])
-	; return (isJust mb_res) }
+  = do  { (_, mb_res) <- tryTc (simplifyDefault [mkClassPred cls [ty]])
+        ; return (isJust mb_res) }
     
 defaultDeclCtxt :: SDoc
 defaultDeclCtxt = ptext (sLit "When checking the types in a default declaration")
diff --git a/compiler/typecheck/TcErrors.lhs b/compiler/typecheck/TcErrors.lhs
index 5b7dd2b..47b6546 100644
--- a/compiler/typecheck/TcErrors.lhs
+++ b/compiler/typecheck/TcErrors.lhs
@@ -1,11 +1,5 @@
 \begin{code}
 {-# LANGUAGE ScopedTypeVariables #-}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcErrors( 
        reportUnsolved, reportAllUnsolved,
@@ -49,9 +43,9 @@ import Data.List        ( partition, mapAccumL, zip4 )
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \section{Errors and contexts}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 ToDo: for these error messages, should we note the location as coming
@@ -144,7 +138,7 @@ report_unsolved mb_binds_var defer wanted
 
 data ReportErrCtxt 
     = CEC { cec_encl :: [Implication]  -- Enclosing implications
-                	       	       --   (innermost first)
+                                       --   (innermost first)
                                        -- ic_skols and givens are tidied, rest are not
           , cec_tidy  :: TidyEnv
           , cec_binds :: Maybe EvBindsVar 
@@ -553,9 +547,9 @@ mkIPErr ctxt cts
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
                 Equality errors
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Note [Inaccessible code]
@@ -664,7 +658,7 @@ mkTyVarEqErr dflags ctxt extra ct oriented tv1 ty2
   -- So tv is a meta tyvar (or started that way before we 
   -- generalised it).  So presumably it is an *untouchable* 
   -- meta tyvar or a SigTv, else it'd have been unified
-  | not (k2 `tcIsSubKind` k1)   	 -- Kind error
+  | not (k2 `tcIsSubKind` k1)            -- Kind error
   = mkErrorMsg ctxt ct $ (kindErrorMsg (mkTyVarTy tv1) ty2 $$ extra)
 
   | OC_Occurs <- occ_check_expand
@@ -731,8 +725,8 @@ mkTyVarEqErr dflags ctxt extra ct oriented tv1 ty2
         -- Not an occurs check, because F is a type function.
   where         
     occ_check_expand = occurCheckExpand dflags tv1 ty2
-    k1 	= tyVarKind tv1
-    k2 	= typeKind ty2
+    k1  = tyVarKind tv1
+    k2  = typeKind ty2
     ty1 = mkTyVarTy tv1
 
 mkEqInfoMsg :: Ct -> TcType -> TcType -> SDoc
@@ -835,7 +829,7 @@ kindErrorMsg ty1 ty2
     k2 = typeKind ty2
 
 --------------------
-misMatchMsg :: Maybe SwapFlag -> TcType -> TcType -> SDoc	   -- Types are already tidy
+misMatchMsg :: Maybe SwapFlag -> TcType -> TcType -> SDoc          -- Types are already tidy
 -- If oriented then ty1 is actual, ty2 is expected
 misMatchMsg oriented ty1 ty2  
   | Just IsSwapped <- oriented
@@ -893,9 +887,9 @@ Warn of loopy local equalities that were dropped.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
                  Type-class errors
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -967,7 +961,7 @@ mk_dict_err ctxt (ct, (matches, unifiers, safe_haskell))
         hang (if isSingleton unifiers 
               then ptext (sLit "Note: there is a potential instance available:")
               else ptext (sLit "Note: there are several potential instances:"))
-    	   2 (ppr_insts unifiers)
+           2 (ppr_insts unifiers)
 
     -- Report "potential instances" only when the constraint arises
     -- directly from the user's use of an overloaded function
@@ -979,7 +973,7 @@ mk_dict_err ctxt (ct, (matches, unifiers, safe_haskell))
       , (orig:origs) <- mapCatMaybes get_good_orig (cec_encl ctxt)
       = [sep [ ptext (sLit "add") <+> pprParendType pred
                <+> ptext (sLit "to the context of")
-	     , nest 2 $ ppr_skol orig $$ 
+             , nest 2 $ ppr_skol orig $$ 
                         vcat [ ptext (sLit "or") <+> ppr_skol orig 
                              | orig <- origs ] ] ]
       | otherwise = []
@@ -987,7 +981,7 @@ mk_dict_err ctxt (ct, (matches, unifiers, safe_haskell))
     ppr_skol (PatSkol dc _) = ptext (sLit "the data constructor") <+> quotes (ppr dc)
     ppr_skol skol_info      = ppr skol_info
 
-	-- Do not suggest adding constraints to an *inferred* type signature!
+        -- Do not suggest adding constraints to an *inferred* type signature!
     get_good_orig ic = case ic_info ic of 
                          SigSkol (InfSigCtxt {}) _ -> Nothing
                          origin                    -> Just origin
@@ -1006,15 +1000,15 @@ mk_dict_err ctxt (ct, (matches, unifiers, safe_haskell))
     -- Normal overlap error
     overlap_msg
       = ASSERT( not (null matches) )
-        vcat [	addArising orig (ptext (sLit "Overlapping instances for") 
-				<+> pprType (mkClassPred clas tys))
+        vcat [  addArising orig (ptext (sLit "Overlapping instances for") 
+                                <+> pprType (mkClassPred clas tys))
 
              ,  ppUnless (null matching_givens) $
                   sep [ptext (sLit "Matching givens (or their superclasses):") 
                       , nest 2 (vcat matching_givens)]
 
-    	     ,	sep [ptext (sLit "Matching instances:"),
-    		     nest 2 (vcat [pprInstances ispecs, pprInstances unifiers])]
+             ,  sep [ptext (sLit "Matching instances:"),
+                     nest 2 (vcat [pprInstances ispecs, pprInstances unifiers])]
 
              ,  ppWhen (null matching_givens && isSingleton matches && null unifiers) $
                 -- Intuitively, some given matched the wanted in their
@@ -1026,12 +1020,12 @@ mk_dict_err ctxt (ct, (matches, unifiers, safe_haskell))
                   sep [ ptext (sLit "There exists a (perhaps superclass) match:") 
                       , nest 2 (vcat (pp_givens givens))]
 
-	     ,	ppWhen (isSingleton matches) $
-		parens (vcat [ ptext (sLit "The choice depends on the instantiation of") <+>
-	    		          quotes (pprWithCommas ppr (varSetElems (tyVarsOfTypes tys)))
-			     , ppWhen (null (matching_givens)) $
+             ,  ppWhen (isSingleton matches) $
+                parens (vcat [ ptext (sLit "The choice depends on the instantiation of") <+>
+                                  quotes (pprWithCommas ppr (varSetElems (tyVarsOfTypes tys)))
+                             , ppWhen (null (matching_givens)) $
                                vcat [ ptext (sLit "To pick the first instance above, use IncoherentInstances")
-			            , ptext (sLit "when compiling the other instance declarations")]
+                                    , ptext (sLit "when compiling the other instance declarations")]
                         ])]
         where
             ispecs = [ispec | (ispec, _) <- matches]
@@ -1299,8 +1293,8 @@ relevantBindings want_filtering ctxt ct
        = do { (tidy_env', tidy_ty) <- zonkTidyTcType tidy_env (idType id)
             ; let id_tvs = tyVarsOfType tidy_ty
                   doc = sep [ pprPrefixOcc id <+> dcolon <+> ppr tidy_ty
-		            , nest 2 (parens (ptext (sLit "bound at")
-			    	 <+> ppr (getSrcLoc id)))]
+                            , nest 2 (parens (ptext (sLit "bound at")
+                                 <+> ppr (getSrcLoc id)))]
                   new_seen = tvs_seen `unionVarSet` id_tvs
 
             ; if (want_filtering && id_tvs `disjointVarSet` ct_tvs)
@@ -1343,10 +1337,10 @@ arising from *runtime* skolems in the debugger.  These
 are created by in RtClosureInspect.zonkRTTIType.  
 
 %************************************************************************
-%*									*
+%*                                                                      *
                  Error from the canonicaliser
-	 These ones are called *during* constraint simplification
-%*									*
+         These ones are called *during* constraint simplification
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -1366,9 +1360,9 @@ solverDepthErrorTcS ct
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                  Tidying
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
